/*
Router - XBee-Serial-Debug-Router 

XBee must get attached to Serial1


*/
#include <XBee.h>
#include <BayXBee.h>
#include <BayEOS.h>
#include <BayDebug.h>

#define RX_SERIAL Serial1

BayDebug client=BayDebug();

XBee xbee_rx = XBee();
Rx16Response rx16 = Rx16Response();


uint16_t rx_panid;
	
unsigned long last_alive_message;

void setup(void){
  xbee_rx.setSerial(RX_SERIAL);
  xbee_rx.begin(38400);

  while(! rx_panid){
    rx_panid=getPANID(xbee_rx);
  }
  
  
  client.begin(19200,1);  
  client.sendMessage("XBee-Router started");

}

void loop(void){
	if((millis()-last_alive_message)>10000){
		last_alive_message=millis();
		client.startDataFrame(BayEOS_Float32le);
		client.addToPayload((uint8_t) 0);
		client.addToPayload((float)(millis()/1000));
		client.sendPayload();	
	}
    xbee_rx.readPacket();
   
    if (xbee_rx.getResponse().isAvailable()) {
      // got something
      if (xbee_rx.getResponse().getApiId() == RX_16_RESPONSE ) {
        // got a rx16 packet
        xbee_rx.getResponse().getRx16Response(rx16);
        if (xbee_rx.getResponse().isError()) {
		// get the error code
			client.startFrame(BayEOS_ErrorMessage);
			client.addToPayload("RX-ERROR:"+xbee_rx.getResponse().getErrorCode());
	    } else {
          //client.startRoutedFrame(rx16.getRemoteAddress16(),rx_panid,rx16.getRssi());
          client.startRoutedFrame(rx16.getRemoteAddress16(),rx_panid);
     	  for(uint8_t i=0; i<rx16.getDataLength();i++){
			client.addToPayload(rx16.getData(i));
		  }
		}
		client.sendPayload();
      }
    }
 }
