#include <Wire.h>
#include <BayEOSBuffer.h>
#include <RTClib.h>
#include <SD.h>
#include <BayEOSBufferSD.h>
#include <BayEOS.h>
#include <XBee.h>
#include <BayXBee.h>


BayXBee client=BayXBee(); 
BayEOSBufferSD myBuffer;
unsigned long last_data;
unsigned long last_buffered_data;
DS3231 myRTC; //Seduino 2.2

void setup(void){
   Wire.begin();
   myRTC.begin();

  client.begin(38400);
  client.sendMessage("Started");
  //Set 4 for EthernetShield, 10 for Stalker
  if (!SD.begin(10)) {
    return;
  }
  
  myBuffer = BayEOSBufferSD(100000000); 
//  myBuffer.setRTC(myRTC); //absolute time! You have to set the RTC!!
//  myBuffer.setRTC(myRTC,false); //relative time! Use RTC instead of millis() to calculate relative time  
  client.setBuffer(myBuffer);
}

void loop(void){

  //Resend buffered frames
  //one every second
  //sending to frequently my make xbee operationable (channel overload)
  if((millis()-last_buffered_data)>1000){
  	  client.sendFromBuffer();
 	  last_buffered_data=millis();
  }

  if((millis()-last_data)>5000){
  	  last_data=millis();
 	  
      myRTC.convertTemperature();  
 	  //Construct DataFrame
      client.startDataFrame(BayEOS_Float32le);
      client.addChannelValue(millis()/1000);  
      client.addChannelValue(myRTC.now().get());  
      client.addChannelValue(myRTC.getTemperature());  
      client.addChannelValue(myBuffer.getTime());
      client.sendOrBuffer();
      
      //Construct Message
      client.startFrame(BayEOS_Message);
      client.addToPayload("Just a message ;-)");
 	  client.sendOrBuffer();
  }                                                                                                                                               

}
