#include "BayEth.h"

#define printP(x) printPGM(PSTR(x))
#define printlnP(x) printPGMln(PSTR(x))

uint8_t BayEth::sendMultiFromBuffer(int maxsize){
	if(! _buffer->available()) return 0;
	uint8_t res;
	res=connect(_server, _server_port);
	if( ! res) return 3;

	unsigned long tmp_long=_buffer->readPos();

	int size=9+strlen(_password);
	if(_sender[0]) size+=7+strlen(_sender)+1;

	while(size<maxsize && readFromBuffer()){
		size+=1+15+base64_enc_len(getPacketLength());
		_buffer->next();
	}
	_buffer->seekReadPointer(tmp_long);
	strcpy_P(_base64buffer,PSTR("POST "));
    strcat(_base64buffer,_server_path);
    strcat_P(_base64buffer,PSTR(" HTTP/1.0"));
    println(_base64buffer);
 	strcpy_P(_base64buffer,PSTR("Content-type: application/x-www-form-urlencoded"));
    println(_base64buffer);
 	strcpy_P(_base64buffer,PSTR("Connection: close"));
 	println(_base64buffer);
    strcpy_P(_base64buffer,PSTR("Content-length: "));
    print(_base64buffer);
  	println(size);
	println();

    strcpy_P(_base64buffer,PSTR("password="));
    strcat(_base64buffer,_password);
	if(_sender[0]){
		strcat_P(_base64buffer,PSTR("&sender="));
		strcat(_base64buffer,_sender);
	}
    print(_base64buffer);

    size=9+strlen(_password);
	if(_sender[0]) size+=7+strlen(_sender)+1;

	while(size<maxsize && readFromBuffer()){
		size+=1+15+base64_enc_len(getPacketLength());
	    strcpy_P(_base64buffer,PSTR("&bayeosframes[]="));
	    print(_base64buffer);
	    base64_encode(_base64buffer,(char*) _payload,getPacketLength());
		_base64buffer[base64_enc_len(getPacketLength())]=0;
		print(_base64buffer);
		_buffer->next();
	}
	println();
 	tmp_long=millis();
 	uint8_t bytes_read=0;
	while((millis()-tmp_long)<_timeout && bytes_read<15){ //HTTP/1.1 200 OK

		if (available()) {
			_base64buffer[bytes_read] = read();
			if(_serial_debug) Serial.print(_base64buffer[bytes_read]);
			bytes_read++;
		}
	}
 	if(_serial_debug) Serial.println();
	stop();

 	if((millis()-tmp_long)>_timeout){
 		return 2;
 	}

	if(_base64buffer[13]=='O' && _base64buffer[14]=='K' && _base64buffer[9]=='2') return 0;//HTTP/1.1 200 OK
    else return 1;

}

uint8_t BayEth::sendPayload(void){
	if(! connect(_server, _server_port)) return 3;
	strcpy_P(_base64buffer,PSTR("POST "));
    strcat(_base64buffer,_server_path);
    strcat_P(_base64buffer,PSTR(" HTTP/1.0"));
    println(_base64buffer);
 	if(_serial_debug) Serial.println(_base64buffer);
 	strcpy_P(_base64buffer,PSTR("Content-type: application/x-www-form-urlencoded"));
    println(_base64buffer);
 	if(_serial_debug) Serial.println(_base64buffer);
	strcpy_P(_base64buffer,PSTR("Connection: close"));
 	println(_base64buffer);
 	if(_serial_debug) Serial.println(_base64buffer);

    strcpy_P(_base64buffer,PSTR("Content-length: "));
    print(_base64buffer);
 	if(_serial_debug) Serial.print(_base64buffer);

    strcpy_P(_base64buffer,PSTR("password="));
    strcat(_base64buffer,_password);
	if(_sender[0]){
		strcat_P(_base64buffer,PSTR("&sender="));
		strcat(_base64buffer,_sender);
	}
	strcat_P(_base64buffer,PSTR("&bayeosframe="));
	_data_length=strlen(_base64buffer)+base64_enc_len(getPacketLength());
  	println(_data_length);
	if(_serial_debug) Serial.println(_data_length);
	println();
	if(_serial_debug) Serial.println();

    //send body...
    print(_base64buffer); //password=xxx&sender=yyy&bayeosframe=
 	if(_serial_debug) Serial.print(_base64buffer);
	_data_length=base64_enc_len(getPacketLength());
	base64_encode(_base64buffer,(char*) _payload,getPacketLength());
	_base64buffer[_data_length+1]='\0';
 	if(_serial_debug) Serial.println(_base64buffer);
    println(_base64buffer); //BASE64
    println();
 	unsigned long send_time=millis();
 	uint8_t bytes_read=0;
	while((millis()-send_time)<_timeout && bytes_read<15){ //HTTP/1.1 200 OK

		if (available()) {
			_base64buffer[bytes_read] = read();
			if(_serial_debug) Serial.print(_base64buffer[bytes_read]);
			bytes_read++;
		}
	}
 	if(_serial_debug) Serial.println();
	stop();

 	if((millis()-send_time)>_timeout){
 		return 2;
 	}

	if(_base64buffer[13]=='O' && _base64buffer[14]=='K' && _base64buffer[9]=='2') return 0;//HTTP/1.1 200 OK
    else return 1;

}


BayEth::BayEth(const uint8_t *server,const char *pw,const char *sender, const char *path, const uint16_t port){
	for(uint8_t i=0;i<4;i++){
		_server[i]=server[i];
	}
	if(sender){
		strncpy(_sender,sender,16);
		_sender[16]=0;
	}
	strncpy(_password,pw,8);
	_password[8]=0;
	strncpy(_server_path,path,16);
	_server_path[16]=0;
	_server_port=port;
	_timeout=3000;
	_serial_debug=0;
}


