#include <OneWire.h>
#include <EEPROM.h>
#include <DS18B20.h>

#include <Base64.h>
#include <BayEOS.h>
#include <Ethernet.h>
#include <SPI.h>
#include <BayEth.h>

#include <SD.h>
#include <BayEOSBuffer.h>
#include <BayEOSBufferSD.h>


BayEOSBufferSD myBuffer;


DS18B20 ds=DS18B20(8,0,4);

uint8_t startup=1;
const byte* new_addr;
uint8_t channel;
float temp;

byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
byte ip[] = { 192, 168, 1, 2 };
byte server[]={ 192, 168, 1, 1 };

BayEth client=BayEth( server,"bayeos","Test_Arduino","/",8090);


unsigned long last_data=0;

void setup(void){
  Ethernet.begin(mac, ip);
  Serial.begin(9600);
  if (!SD.begin(4)) {  	
  	delay(1000);
    return;
  }
  myBuffer = BayEOSBufferSD(1000000); 
}

void loop(void){
  if(startup){
    ds.setAllAddrFromEEPROM();
    ds.setAllAddr(); //Sucht nach neuen Sensoren und registriert diese
    startup=0;
  }
  if((millis()-last_data)>5000){
	ds.t_conversion();
  	delay(1000);
  	bayeos_sender.startDataFrame(0x41);
   	while(channel=ds.getNextChannel()){
       	if(! ds.readChannel(channel,&temp)){
        	 bayeos_sender.addToPayload(channel);
         	bayeos_sender.addToPayload(temp);
       		} 
	}
	bayeos_sender.sendOrBuffer();
   }
   bayeos_sender.sendFromBuffer();
  
}