/*
Router - XBee-GPRS with SD-Card Buffer

GPRS-Shield uses Serial1

Test-Multi-Frame


 
*/

#include <BayEOS.h>
#include <SPI.h>
#include <Base64.h>
#include <BayGPRS.h>
#include <BayEOSBuffer.h>
#include <SdFat.h>
#include <BayEOSBufferSDFat.h>

#define TX_SERIAL Serial1

/* Please define your BayEOS-Gateway url, password, a name for the GPRS-router and 
the apn of your provider */

BayGPRS client=BayGPRS("http://127.0.0.1:8090/",
   "bayeos","SIGNAL-D-UBT","web.vodafone.de",
   TX_SERIAL);

//BayDebug client;
BayEOSBufferSDFat myBuffer;
	
/*
 * Create a huge ring buffer to store incoming RX Packages while
 * arduino is busy with GPRS...
 */

unsigned long last_alive;

void setup(void){
  pinMode(53, OUTPUT);
  pinMode(10, OUTPUT);
  pinMode(4, OUTPUT);
  
  Serial.begin(9600);
  Serial.println("Starting");
  client._serial_debug=0;
  client.begin(19200);
  client.connect();
 //Use 4 for Ethernet-Shield
// "A11" for Mega-XBee-Shield
  if (!SD.begin(4)) {
  	client.sendError("No SD.");
        return;
  }
  myBuffer = BayEOSBufferSDFat(10000000);
  client.setBuffer(myBuffer,0);
  Serial.println("Setup ok");

   
}

void loop(void){
  Serial.println("Creating Frame");
      client.startDataFrame(BayEOS_Float32le);
      client.addChannelValue(((float)millis())/1000);
      client.addChannelValue(myBuffer.writePos());
      client.addChannelValue(myBuffer.readPos());
      client.writeToBuffer();
      delay(1000);
    
  
    if(millis()-last_alive>30000){
      Serial.print("RSSI:");
      Serial.println(client.getRSSI());
      client.now();
      Serial.print("Sending frame .... ");
      last_alive=millis();
      client.sendMultiFromBuffer();
      Serial.println("done");
    }
}
